#------------------------------------------------------------------------------
#This script list of file and their modified dates. 

# Author : Doug Cameron
# Last Date Modified : Feb 9, 2010


#-------------------------------------------------------------------------------------------------------------------------
#Import all the modules required

import os, sys, shutil, glob, re, time, difflib, cx_Oracle, traceback, smtplib, datetime
from time import gmtime, strftime

sql_err_message = ""
sql_err_message_new = ""
email_message_db_error = ""
del_file_message = ""

#--------------------------------------------------------------------------------------------------------------------------
def set_sql_err_message():

    etype = sys.exc_info()[0]
    evalue = sys.exc_info()[1]
    etb = traceback.extract_tb(sys.exc_info()[2])

    sql_err_message_new = 'Error in the GIS update routine.\n'
    sql_err_message_new += 'Error Type: ' + str(etype) + '\n'
    sql_err_message_new += 'Error Value: ' + str(evalue) + '\n'
    sql_err_message_new += 'Traceback: ' + str(etb) + '\n\n'

    return sql_err_message_new 
    
#-----------------------------------------------------------------------------------------------------------------------------------------
#Read the table with previously stored Cmap filenames and modifed dates
#final_info_file = open('S:\\landbase\\MappingServices\\WorkingFiles\\Dataloading_temp\\Updating_DB\\File_lists\\Final_list.txt', "r")


try:
    connection = cx_Oracle.connect(u'gis_staging/g1s@devfdbsl')# Establish the Oracle connection

    # Create a cursor
    cursor = connection.cursor()

    if cursor: #if there is a cursor connection

        try:
            # Call the Procedure

            sqlstr = u"TRUNCATE TABLE val_results" 
            cursor.execute(sqlstr)#execute the update sql statement
            connection.commit()

            cursor.execute(u"""
            BEGIN
            SDO_GEOM.VALIDATE_LAYER_WITH_CONTEXT('GIS_PARCELS_T','GEOMETRY1','VAL_RESULTS', 100);
            END;""")
            connection.commit()

            sqlstr = u"SELECT * FROM val_results" 
            cursor.execute(sqlstr)#execute the update sql statement
            connection.commit()

            rows = cursor.fetchall()
            for row in rows:   
               print row

            sqlstr2 = u"SELECT * FROM GIS_PARCELS_T a , VAL_RESULTS b WHERE a.ROWID = b.sdo_rowid" 
            cursor.execute(sqlstr2)#execute the update sql statement
            connection.commit()

            rows2 = cursor.fetchall()
            for row2 in rows2:   
               print row2
            #for row in rows:   
                #for col in rows:   
                    #print "%s," % col


               
        except cx_Oracle.DatabaseError:#if the select sql statement didn't work, create error message

            sql_err_message_new = set_sql_err_message()
            sql_err_message = sql_err_message+sql_err_message_new
            print sql_err_message

except cx_Oracle.DatabaseError: #if there is problem connecting to Oracle or a table

    sql_err_message_new = set_sql_err_message()
    sql_err_message = sql_err_message+sql_err_message_new
    print sql_err_message

# Close the connection and cursor 
cursor.close()
connection.close()
